// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlBox")]
    pub struct Box(Object<ffi::DzlBox, ffi::DzlBoxClass>) @extends gtk::Box, gtk::Container, gtk::Widget, @implements gtk::Buildable, gtk::Orientable;

    match fn {
        type_ => || ffi::dzl_box_get_type(),
    }
}

impl Box {
    pub const NONE: Option<&'static Box> = None;

    #[doc(alias = "dzl_box_new")]
    pub fn new() -> Box {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_box_new()).unsafe_cast() }
    }
}

impl Default for Box {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Box>> Sealed for T {}
}

pub trait BoxExt: IsA<Box> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_box_get_max_width_request")]
    #[doc(alias = "get_max_width_request")]
    fn max_width_request(&self) -> i32 {
        unsafe { ffi::dzl_box_get_max_width_request(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_box_get_nth_child")]
    #[doc(alias = "get_nth_child")]
    fn nth_child(&self, nth: u32) -> Option<gtk::Widget> {
        unsafe {
            from_glib_none(ffi::dzl_box_get_nth_child(
                self.as_ref().to_glib_none().0,
                nth,
            ))
        }
    }

    #[doc(alias = "dzl_box_set_max_width_request")]
    fn set_max_width_request(&self, max_width_request: i32) {
        unsafe {
            ffi::dzl_box_set_max_width_request(self.as_ref().to_glib_none().0, max_width_request);
        }
    }

    #[doc(alias = "max-width-request")]
    fn connect_max_width_request_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_max_width_request_trampoline<
            P: IsA<Box>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlBox,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Box::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::max-width-request\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_max_width_request_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<Box>> BoxExt for O {}

impl fmt::Display for Box {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Box")
    }
}
